/* file: memptr.i
 * Allow string operations on memory pointer based data
 * used for .so and socket operations.
 *
 * Written by Scott Auge scott_auge@yahoo.com
 * Copyright (c) 2001 Amduus Information Works, Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by Amduus Information Works
 *      and its contributors.
 * 4. Neither the name of Amduus nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AMDUUS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AMDUUS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *
 */


DEF VAR RCSVersionMemptri AS CHARACTER INIT "$Header: /home/appl/sdk/email/src/RCS/memptr.i,v 1.1 2001/08/23 23:50:35 sauge Exp sauge $" NO-UNDO. 

PROCEDURE lmemset:

  DEF INPUT PARAMETER m AS MEMPTR NO-UNDO.
  DEF INPUT PARAMETER c AS CHARACTER NO-UNDO.
  
  DEF VAR i AS INTEGER INIT 1 NO-UNDO.
  
  DO while i < GET-SIZE(m):
    PUT-BYTE (mData, i) = ASC (c).
    ASSIGN i = i + 1.
  END.
  
END.

PROCEDURE lmemput:

  DEF INPUT PARAMETER m AS MEMPTR NO-UNDO.
  DEF INPUT PARAMETER s AS CHARACTER NO-UNDO.

  DEF VAR i AS INTEGER INIT 1 NO-UNDO.

  DO WHILE i < GET-SIZE(m):
    IF i < LENGTH (s) + 1 THEN
      PUT-BYTE (mData, i) = ASC(SUBSTRING (s, i, 1)).
    ELSE
      PUT-BYTE (mData, i) = 0.
    ASSIGN i = i + 1.
  END.

END.

PROCEDURE lmemget:

  DEF INPUT PARAMETER  m AS memptr NO-UNDO.
  DEF OUTPUT PARAMETER c AS CHARACTER NO-UNDO.
  
  c = GET-BYTES (mData, 1, GET-SIZE(mData)).

END.
